## acl2 8.2dfsg

=== books/make-event/Makefile ===
include ../Makefile-generic
-include Makefile-deps

# Added manually, for the case of provisional certification
# (ACL2_PCERT=t); see last form in .lisp file.
local-requires-skip-check-include.pcert0: local-requires-skip-check.cert
local-elided-include.pcert0: local-elided.cert

# Added manually, based on *default-arith-book-alist*:
# proof-by-arith.cert: $(ACL2_SYSTEM_BOOKS)/arithmetic-3/bind-free/top.cert
# proof-by-arith.cert: $(ACL2_SYSTEM_BOOKS)/arithmetic-3/floor-mod/floor-mod.cert
# proof-by-arith.cert: $(ACL2_SYSTEM_BOOKS)/arithmetic/top-with-meta.cert
# proof-by-arith.cert: $(ACL2_SYSTEM_BOOKS)/rtl/rel5/arithmetic/top.cert

=== books/projects/apply-model/Makefile ===
# Target "all" is the top target of Makefile-generic.  We avoid
# including Makefile-subdirs or Makefile-psubdirs because we want to
# be sure to control the order: first this directory, then
# subdirectories.

ACL2 ?= ../../../saved_acl2
ACL2_SYSTEM_BOOKS ?= ../..

.PHONY: top all-subdirs ex1 ex2 clean-subdirs

top: all
	$(MAKE) all-subdirs

include $(ACL2_SYSTEM_BOOKS)/Makefile-generic
-include Makefile-deps

all-subdirs: ex1 ex2

ex1:
	cd ex1 ; $(MAKE)

ex2:
	cd ex2 ; $(MAKE)

clean: clean-subdirs

clean-subdirs:
	cd ex1 ; $(MAKE) clean
	cd ex2 ; $(MAKE) clean

=== books/projects/rac/Makefile ===
export ACL2?=~/acl2
export RAC?=${ACL2}/books/projects/rac

all:
	(cd src; make all)
	(cd lisp; make all)

clean:
	(cd lisp; make clean)
	(cd src; make clean)
	(cd examples; make clean)

veryclean: clean
	(cd lisp; make veryclean)
	(cd src; make veryclean)
	(cd examples; make veryclean)

=== books/projects/sidekick/Makefile ===
# ACL2 Sidekick
# Copyright (C) 2014 Kookamara LLC
#
# Contact:
#
#   Kookamara LLC
#   11410 Windermere Meadows
#   Austin, TX 78759, USA
#   http://www.kookamara.com/
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Jared Davis <jared@kookamara.com>

.PHONY: all clean

all:

SHELL := $(shell which bash)
STARTJOB ?= $(SHELL)
ACL2 ?= acl2

$(info Scanning for dependencies...)
REBUILD_MAKEFILE_DEPS := $(shell \
  rm -f Makefile-deps Makefile-deps.out; \
  cert.pl --quiet \
          --static-makefile Makefile-deps \
          --cache Makefile-cache \
          top.cert \
          1>&2) ;\
  echo 'MFDEPS_DEBUG := $$(shell echo Reading book deps ' \
       'Makefile-deps created on' `date` '1>&2)' \
    >> Makefile-deps; \
  ls -l Makefile-deps)
#$(info $(REBUILD_MAKEFILE_DEPS))
$(info Done scanning.)

include Makefile-deps

all: top.cert sidekick

clean:
	clean.pl
	rm -f Makefile-deps Makefile-cache Makefile-tmp
	rm -f sidekick sidekick.ccl

sidekick: top.cert make-sidekick.lsp
	rm -f sidekick sidekick.ccl
	$(STARTJOB) -c "SIDEKICK_NO_AUTOLOAD=1 ACL2_CUSTOMIZATION=NONE $(ACL2) < make-sidekick.lsp &> sidekick.out"
	ls -lah sidekick

=== books/centaur/sv/cosims/Makefile ===
# SV - Symbolic Vector Hardware Analysis Framework
# Copyright (C) 2014-2015 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Sol Swords <sswords@centtech.com>

.PHONY: all

all:

# ---------------------------------------
#  Building the cosim image

STARTJOB ?= $(SHELL)
ACL2 ?= acl2

# For any extra VCS/NCVerilog flags
VCS_FLAGS ?=
NCV_FLAGS ?=

CORE := ./cosim-core
IMG_EXT ?= lx86cl64

ACL2_SYSTEM_BOOKS ?= ../../..

$(info Rebuilding Makefile-books...)
REBUILD_MAKEFILE_BOOKS := $(shell \
	$(ACL2_SYSTEM_BOOKS)/build/cert.pl cosims.lisp \
		--quiet \
		--static-makefile Makefile-books \
		--var-prefix BOOKS_TOP; \
        ls -l Makefile-books ;\
	)
$(info $(REBUILD_MAKEFILE_BOOKS))
$(info Done rebuilding makefiles)

-include Makefile-books

cosim-core: cosims.cert make-cosim.lsp
	@rm -f $(CORE)
	@$(STARTJOB) -c "$(ACL2) < make-cosim.lsp &> make-cosim.out"
	@ls -l cosim-core

all: cosim-core symlinks

.PHONY: symlinks

# ------------------------------------------
#  Test setup.
FAILING_TEST_TARGETS := \
  for-nba/ok \
  task/ok \
  task2/ok \
  case_wilds/ok \
  gates_cmos/ok \
  gates_pmos/ok \
  gates_nmos/ok \
  gates_rpmos/ok \
  gates_rnmos/ok \
  gates_pullup/ok \
  gates_pulldown/ok \
  inst_size1/ok \
  inst_size2/ok \
  inst_size3/ok \
  inst_size4/ok \
  sqrt/ok \
  udp_wide1/ok \
  fns3/ok \
  bind5/ok \
  float1/ok \
  paramtypes3/ok \
  paramtypes4/ok \
  param3/ok \
  iface_basic7/ok

SPECFILES := $(wildcard */spec.sv)
TESTS := $(patsubst %/spec.sv,%,$(SPECFILES))
TESTCERTS := $(patsubst %,%/ok,$(TESTS))
OUTDATAS_NCV := $(patsubst %,%/outputs.ncv.data,$(TESTS))
OUTDATAS_VCS := $(patsubst %,%/outputs.vcs.data,$(TESTS))
OUTDATAS_IV  := $(patsubst %,%/outputs.iv.data,$(TESTS))

PASSING_TESTS := $(filter-out $(FAILING_TEST_TARGETS), $(TESTCERTS))
OUTDIRS_VCS := $(patsubst %,%/simv.daidir,$(TESTS))
print_tests :
	@echo $(TESTS)

# %/ok : %/outputs.ncv.data %/outputs.vcs.data %/outputs.iv.data cosim-core
%/ok : %/outputs.ncv.data %/outputs.vcs.data cosim-core
	@echo "Making $*/ok"
	@rm -f $*.ok $*/cosim.out
	COSIM_TESTDIR=$* $(STARTJOB) -c "./cosim-core < run.lsp &> $*/cosim.out"
	@! egrep -i "failed|error" $*/cosim.out > /dev/null
	@mv $*/cosim.out $*/ok
	@ls -l $*/ok

%/outputs.ncv.data : %/spec.sv twovalued.data fourvalued.data test.sv
	@echo "Making $*/outputs.ncv.data"
	@cd $*; \
         if [ -e twovalued ]; then \
           infile=../twovalued.data; \
         else \
           infile=../fourvalued.data; \
         fi; \
	 if [ -e no_ncv ]; then \
		touch outputs.ncv.data; \
         else \
		ncverilog $(NCV_FLAGS) -sv spec.sv ../test.sv +define+infile=\"$$infile\" +define+outfile=\"outputs.ncv.data\" +define+test_define=3 +test_is_$* ; \
	 fi
	@ls -l $*/outputs.ncv.data

%/outputs.vcs.data : %/spec.sv twovalued.data fourvalued.data test.sv
	@echo "Making $*/outputs.vcs.data"
	@cd $*; \
         if [ -e twovalued ]; then \
           infile=../twovalued.data; \
         else \
           infile=../fourvalued.data; \
         fi; \
	 if [ -e no_vcs ]; then \
		touch outputs.vcs.data; \
	 else \
		 vcs $(VCS_FLAGS) -sverilog spec.sv ../test.sv +define+infile=\"$$infile\" +define+outfile=\"outputs.vcs.data\" +define+test_define=3 +test_is_$* && ./simv; \
	 fi
	@ls -l $*/outputs.vcs.data

%/outputs.iv.data : %/spec.sv twovalued.data fourvalued.data test.sv
	@echo "Making $*/outputs.iv.data"
	@cd $*; \
         if [ -e twovalued ]; then \
           infile=../twovalued.data; \
         else \
           infile=../fourvalued.data; \
         fi; \
	 if [ -e no_iv ]; then \
		touch outputs.iv.data; \
	 else \
		 iverilog -g2012 spec.sv ../test.sv -Dinfile=\"$$infile\" -Doutfile=\"outputs.iv.data\" && ./a.out; \
	 fi
	@ls -l $*/outputs.iv.data

.PHONY: ncv
ncv : $(OUTDATAS_NCV)

.PHONY: vcs
vcs : $(OUTDATAS_VCS)

.PHONY: iv
iv  : $(OUTDATAS_IV)

.PHONY: passing
passing : $(PASSING_TESTS)

.phony: failing
failing: $(FAILING_TEST_TARGETS)

# all : $(TESTCERTS) ncv vcs iv
all : $(TESTCERTS) ncv vcs

.PHONY: cleansim
cleansim:
	rm -f $(OUTDATAS_NCV) $(OUTDATAS_VCS) $(OUTDATAS_IV)
	rm -rf $(OUTDIRS_VCS)
	rm -rf */INCA_libs
	rm -rf */csrc
	rm -rf */simv.daidir
	rm -f */simv
	rm -f */a.out
	rm -f */irun.history */ncverilog.history
	rm -f */ncverilog.log
	rm -f */test.vcd
	rm -f */ucli.key
	rm -f */ok

.PHONY: clean
clean: cleansim

# [Jared] hack so you can just write "make always1" or similar, adapted
# from vl linttests

.PHONY: $(TESTS)

define mkDirTarget
$(1): $(1)/ok
endef

$(foreach dir, $(TESTS), $(eval $(call mkDirTarget, $(dir))))

=== books/kestrel/java/aij/Makefile ===
# Java Library -- AIJ -- Compilation
#
# Copyright (C) 2018 Kestrel Institute (http://www.kestrel.edu)
#
# License: A 3-clause BSD license. See the LICENSE file distributed with ACL2.
#
# Author: Alessandro Coglio (coglio@kestrel.edu)

################################################################################

# This file compiles the Java source files of AIJ without IntelliJ IDEA.
# It generates the class and jar files in the same places as IntelliJ IDEA does.
# It assumes that OpenJDK Java 11 is in the path,
# but it may well work with other Java versions or implementations.

################################################################################

aij: java/out/artifacts/AIJ_jar/AIJ.jar

java/out/artifacts/AIJ_jar/AIJ.jar: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate class files:"
	mkdir -p java/out/production/AIJ
	javac -d java/out/production/AIJ java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate jar file:"
	mkdir -p java/out/artifacts/AIJ_jar
	jar cfM java/out/artifacts/AIJ_jar/AIJ.jar -C java/out/production/AIJ/ .

clean:
	@echo "Delete class files and jar file:"
	/bin/rm -rf java/out

=== books/projects/apply-model/ex1/Makefile ===
SHELL ?= $(shell which bash)

ACL2 ?= ../../../../saved_acl2

ACL2_SYSTEM_BOOKS ?= ../../..

include $(ACL2_SYSTEM_BOOKS)/Makefile-generic

clean: clean-more

.PHONY: clean-more
clean-more:
	rm -f evaluation-apply.lisp evaluation-user-defs.lisp Makefile-deps

REBUILD_MAKEFILE_DEPS := $(shell \
  rm -f Makefile-deps Makefile-deps.out && \
  (diff ../apply.lisp evaluation-apply.lisp 2>&1 > /dev/null || \
   cp -pf ../apply.lisp evaluation-apply.lisp) && \
  (diff user-defs.lisp evaluation-user-defs.lisp 2>&1 > /dev/null || \
   cp -pf user-defs.lisp evaluation-user-defs.lisp) && \
  $(ACL2_SYSTEM_BOOKS)/build/cert.pl --include-excludes -s Makefile-deps *.lisp)

-include Makefile-deps

=== books/projects/filesystems/test/Makefile ===
# test-stat-replicant-1 and test-stat-replicant-2 are left out from
# this list for reasons explained in a comment below.
TEST:= test-cp-replicant-1 test-cp-replicant-2 test-cp-replicant-3 \
test-cp-replicant-4 mtools-test-cp-replicant-2 \
test-mkfs-replicant-1 test-mkfs-replicant-2 \
test-wc-replicant-1 test-wc-replicant-2 test-wc-replicant-3 \
test-rm-replicant-1 test-rm-replicant-2 test-rm-replicant-3 \
test-rm-replicant-4 mtools-test-rm-replicant-1 \
mtools-test-rm-replicant-2 \
test-unlink-replicant-1 test-unlink-replicant-2 \
test-unlink-replicant-3 \
test-mkdir-replicant-1 test-mkdir-replicant-2 \
mtools-test-mkdir-replicant-1 \
test-rmdir-replicant-1 test-rmdir-replicant-2 \
mtools-test-rmdir-replicant-1 \
test-mv-replicant-1 mtools-test-mv-replicant-1 \
mtools-test-mv-replicant-2

test: $(TEST)

.PHONY: clean-mountpoint test $(TEST)

.PHONY: debug-create-dir-and-file debug-create-dir debug-do-nothing \
debug-create-dir-copy-file

.PHONY: mtools-read-write-test-128MB \
mtools-read-write-test-256MB \
mtools-read-write-test-512MB mtools-read-write-test-1024MB

# FUSEPOINT and BBFS are commented below because they refer to Joseph
# Pfeiffer's pedagogical Big Brother Filesystem, which I used in some
# of the tests. For almost every test, they only helped log the
# syscalls and their return values without affecting the course of the
# test; however, the stat tests test-stat-replicant-1 and
# test-stat-replicant-2 do rely on them. Without the interposition of
# the FUSE layer, the id value in the struct statfs can be completely
# arbitrary depending on mount time details which our stat
# implementation has no access to, but when FUSE is interposed, a 0
# value is assigned to id. This value is hard-coded in the stat
# tests; they can be run by downloading and compiling BBFS
# (https://www.cs.nmsu.edu/~pfeiffer/fuse-tutorial/) and noting the
# path to the executable in the BBFS variable, below.
DISK=disk1.raw
SIZE=70000
MOUNTPOINT=mount1
# FUSEPOINT=mount2
# BBFS=$(HOME)/src/bbfs/fuse-tutorial-2018-02-04/src/bbfs
UID=$(shell id -u)
GID=$(shell id -g)
MTOOLSRC=$(shell pwd)/.mtoolsrc

clean-mountpoint:
	rm -rf $(MOUNTPOINT)

$(MOUNTPOINT):
	rm -rf $(MOUNTPOINT)
	mkdir -p $(MOUNTPOINT)

# $(FUSEPOINT):
# 	rm -rf $(FUSEPOINT)
# 	mkdir -p $(FUSEPOINT)

test-cp-replicant-1: cp-ref-output-1.txt cp-output-1.txt
	diff -u -i cp-ref-output-1.txt cp-output-1.txt

test-cp-replicant-2: cp-ref-output-2.txt cp-output-2.txt
	diff -u -i cp-ref-output-2.txt cp-output-2.txt

test-cp-replicant-3: cp-ref-output-3.txt cp-output-3.txt
	diff -u -i cp-ref-output-3.txt cp-output-3.txt

test-cp-replicant-4: cp-ref-output-4.txt cp-output-4.txt
	diff -u -i cp-ref-output-4.txt cp-output-4.txt

mtools-test-cp-replicant-2: mtools-cp-ref-output-2.txt mtools-cp-output-2.txt
	diff -u -i mtools-cp-ref-output-2.txt mtools-cp-output-2.txt

test-cp-replicant-5: cp-ref-output-5.txt cp-output-5.txt
	diff -u -i cp-ref-output-5.txt cp-output-5.txt

test-mkfs-replicant-1: mkfs-ref-output-1.txt mkfs-output-1.txt
	diff -u -i mkfs-ref-output-1.txt mkfs-output-1.txt

test-mkfs-replicant-2: mkfs-ref-output-2.txt mkfs-output-2.txt
	diff -u -i mkfs-ref-output-2.txt mkfs-output-2.txt

test-mkfs-replicant-3: mkfs-ref-output-3.txt mkfs-output-3.txt
	diff -u -i mkfs-ref-output-3.txt mkfs-output-3.txt

test-wc-replicant-1: wc-ref-output-1.txt wc-output-1.txt
	diff -u -i wc-ref-output-1.txt wc-output-1.txt

test-wc-replicant-2: wc-ref-output-2.txt wc-output-2.txt
	diff -u -i wc-ref-output-2.txt wc-output-2.txt

test-wc-replicant-3: wc-ref-output-3.txt wc-output-3.txt
	diff -u -i wc-ref-output-3.txt wc-output-3.txt

test-stat-replicant-1: stat-ref-output-1.txt stat-output-1.txt
	diff -u -i stat-ref-output-1.txt stat-output-1.txt

test-stat-replicant-2: stat-ref-output-2.txt stat-output-2.txt
	diff -u -i stat-ref-output-2.txt stat-output-2.txt

test-rm-replicant-1: rm-output-1.raw rm-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="rm-ref-output-1.raw" \
	INPUT="rm-output-1.raw" $(ACL2) -- < compare-disks.lisp

test-rm-replicant-2: rm-output-2.raw rm-ref-output-2.raw
	env DISK=$(DISK) REF_INPUT="rm-ref-output-2.raw" \
	INPUT="rm-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-rm-replicant-3: rm-output-3.raw rm-ref-output-3.raw
	env DISK=$(DISK) REF_INPUT="rm-ref-output-3.raw" \
	INPUT="rm-output-3.raw" $(ACL2) -- < compare-disks.lisp

test-rm-replicant-4: rm-output-4.raw rm-ref-output-4.raw
	env DISK=$(DISK) REF_INPUT="rm-ref-output-4.raw" \
	INPUT="rm-output-4.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-rm-replicant-1: mtools-rm-ref-output-1.raw mtools-rm-output-1.raw
	env DISK=$(DISK) REF_INPUT="mtools-rm-ref-output-1.raw" \
	INPUT="mtools-rm-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-rm-replicant-2: mtools-rm-ref-output-2.raw mtools-rm-output-2.raw
	env DISK=$(DISK) REF_INPUT="mtools-rm-ref-output-2.raw" \
	INPUT="mtools-rm-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-unlink-replicant-1: unlink-output-1.raw unlink-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="unlink-ref-output-1.raw" \
	INPUT="unlink-output-1.raw" $(ACL2) -- < compare-disks.lisp

test-unlink-replicant-2: unlink-output-2.raw unlink-ref-output-2.raw
	env DISK=$(DISK) REF_INPUT="unlink-ref-output-2.raw" \
	INPUT="unlink-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-unlink-replicant-3: unlink-output-3.raw unlink-ref-output-3.raw
	env DISK=$(DISK) REF_INPUT="unlink-ref-output-3.raw" \
	INPUT="unlink-output-3.raw" $(ACL2) -- < compare-disks.lisp

test-mkdir-replicant-1: mkdir-output-1.raw mkdir-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="mkdir-ref-output-1.raw" \
	INPUT="mkdir-output-1.raw" $(ACL2) -- < compare-disks.lisp

test-mkdir-replicant-2: mkdir-output-2.raw mkdir-ref-output-2.raw
	env DISK=$(DISK) REF_INPUT="mkdir-ref-output-2.raw" \
	INPUT="mkdir-output-2.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-mkdir-replicant-1: mtools-mkdir-ref-output-1.raw mtools-mkdir-output-1.raw
	env DISK=$(DISK) REF_INPUT="mtools-mkdir-ref-output-1.raw" \
	INPUT="mtools-mkdir-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-mkdir-replicant-2: mtools-mkdir-ref-output-2.raw mtools-mkdir-output-2.raw
	env DISK=$(DISK) REF_INPUT="mtools-mkdir-ref-output-2.raw" \
	INPUT="mtools-mkdir-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-rmdir-replicant-1: rmdir-output-1.raw rmdir-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="rmdir-ref-output-1.raw" \
	INPUT="rmdir-output-1.raw" $(ACL2) -- < compare-disks.lisp

test-rmdir-replicant-2: rmdir-output-2.raw rmdir-ref-output-2.raw
	env DISK=$(DISK) REF_INPUT="rmdir-ref-output-2.raw" \
	INPUT="rmdir-output-2.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-rmdir-replicant-1: mtools-rmdir-ref-output-1.raw mtools-rmdir-output-1.raw
	env DISK=$(DISK) REF_INPUT="mtools-rmdir-ref-output-1.raw" \
	INPUT="mtools-rmdir-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-rmdir-replicant-2: mtools-rmdir-ref-output-2.raw mtools-rmdir-output-2.raw
	env DISK=$(DISK) REF_INPUT="mtools-rmdir-ref-output-2.raw" \
	INPUT="mtools-rmdir-output-2.raw" $(ACL2) -- < compare-disks.lisp

test-mv-replicant-1: mv-output-1.raw mv-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="mv-ref-output-1.raw" \
	INPUT="mv-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-mv-replicant-1: mtools-mv-output-1.raw mtools-mv-ref-output-1.raw
	env DISK=$(DISK) REF_INPUT="mtools-mv-ref-output-1.raw" \
	INPUT="mtools-mv-output-1.raw" $(ACL2) -- < compare-disks.lisp

mtools-test-mv-replicant-2: mtools-mv-ref-output-2.raw mtools-mv-output-2.raw
	env DISK=$(DISK) REF_INPUT="mtools-mv-ref-output-2.raw" \
	INPUT="mtools-mv-output-2.raw" $(ACL2) -- < compare-disks.lisp

cp-ref-output-1.txt cp-output-1.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	echo "four" > $(MOUNTPOINT)/vmlinuz
	cat $(MOUNTPOINT)/vmlinuz > cp-ref-output-1.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-1.txt" \
	CP_INPUT="/vmlinuz" $(ACL2) < cp-replicant.lisp

cp-ref-output-2.txt cp-output-2.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-1204-bytes.txt $(MOUNTPOINT)/vmlinuz
	cat $(MOUNTPOINT)/vmlinuz > cp-ref-output-2.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-2.txt" \
	CP_INPUT="/vmlinuz" $(ACL2) < cp-replicant.lisp

cp-ref-output-3.txt cp-output-3.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-1204-bytes.txt $(MOUNTPOINT)/vmlinuz
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	cat $(MOUNTPOINT)/initrd.img > cp-ref-output-3.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-3.txt" \
	CP_INPUT="/initrd.img" $(ACL2) < cp-replicant.lisp

cp-ref-output-4.txt cp-output-4.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	for i1 in $(shell seq 1 32); do \
		cp input-1204-bytes.txt $(MOUNTPOINT)/initrd$$i1.img; \
	done
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	cat $(MOUNTPOINT)/initrd.img > cp-ref-output-4.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-4.txt" \
	CP_INPUT="/initrd.img" $(ACL2) < cp-replicant.lisp

cp-ref-output-5.txt cp-output-5.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-1204-bytes.txt $(MOUNTPOINT)/initrd.img
	sync $(MOUNTPOINT)/initrd.img
	rm $(MOUNTPOINT)/initrd.img
	for i1 in $(shell seq 1 32); do \
		cp input-1204-bytes.txt $(MOUNTPOINT)/initrd$$i1.img; \
	done
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	cat $(MOUNTPOINT)/initrd.img > cp-ref-output-5.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-5.txt" \
	CP_INPUT="/initrd.img" $(ACL2) < cp-replicant.lisp

mtools-cp-ref-output-2.txt mtools-cp-output-2.txt: cp-replicant.lisp
	rm -f $(DISK) mtools-cp-ref-output-2.txt
	dd if=/dev/zero of=$(DISK) bs=4096 count=17920
	env MTOOLSRC=$(MTOOLSRC) mformat -T 140000 -h 64 -s 32 -S \
	2 -F -c 2 c:
	env MTOOLSRC=$(MTOOLSRC) mcopy input-1204-bytes.txt c:/vmlinuz
	env MTOOLSRC=$(MTOOLSRC) mcopy c:/vmlinuz mtools-cp-ref-output-2.txt
	env DISK=$(DISK) CP_OUTPUT="mtools-cp-output-2.txt" \
	CP_INPUT="/vmlinuz" $(ACL2) < cp-replicant.lisp

mkfs-ref-output-1.txt mkfs-output-1.txt: $(MOUNTPOINT) \
mkfs.fat-3.0.28-replicant.lisp
	rm -f $(DISK)
	(mkfs.fat -C -v -F 32 -s 1 $(DISK) $(SIZE)) > mkfs-ref-output-1.txt
	env DISK=$(DISK) MKFS_OUTPUT="mkfs-output-1.txt" $(ACL2) < \
	mkfs.fat-3.0.28-replicant.lisp

mkfs-ref-output-2.txt mkfs-output-2.txt: $(MOUNTPOINT) \
mkfs.fat-3.0.28-replicant.lisp
	rm -f $(DISK)
	(mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)) > mkfs-ref-output-2.txt
	env DISK=$(DISK) MKFS_OUTPUT="mkfs-output-2.txt" $(ACL2) < \
	mkfs.fat-3.0.28-replicant.lisp

wc-ref-output-1.txt wc-output-1.txt: $(MOUNTPOINT) wc-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	wc -c < $(MOUNTPOINT)/initrd.img > wc-ref-output-1.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) WC_OUTPUT="wc-output-1.txt" \
	WC_INPUT="/initrd.img" $(ACL2) -- -c < wc-replicant.lisp

wc-ref-output-2.txt wc-output-2.txt: $(MOUNTPOINT) wc-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-4623-bytes.txt $(MOUNTPOINT)/initrd.img
	wc -l < $(MOUNTPOINT)/initrd.img > wc-ref-output-2.txt
	sleep 1
	sudo umount $(MOUNTPOINT)

=== books/projects/rac/lisp/Makefile ===

all: translate.cert

translate.cert: translate.lisp
	echo '(certify-book "translate")' | ${ACL2}/saved_acl2

clean:

veryclean: clean
	rm -f *.cert *.*x64fsl *.port *.cert.time *.cert.out *.fasl

=== books/projects/translators/l3-to-acl2/Makefile ===
# WARNING: Do not run with -j (unless it's -j 1)!  Otherwise you may
# get errors.

# We compute the variable ACL2_DIR if it is not already defined.
# Using only pwd on Windows, Harsh Raju Chamarthi reported a failure.
# It turned out that the cbd seemed was set to a path of the form
# "C:/msys/home/...", but an include-book command failed with
# corresponding pathname "/home/...".  So we make an attempt to
# include the leading "C:/msys" for msys/mingw, and for cygwin we try
# to get a suitable value using cygpath.

ifneq ($(findstring MINGW, $(shell uname)),)
ACL2_DIR ?= $(shell cd ../../../.. ; pwd -W)
else
ifneq ($(findstring CYGWIN, $(shell uname)),)
ACL2_DIR ?= $(shell cd ../../../.. ; cygpath -m `pwd`)
else
ACL2_DIR ?= $(shell cd ../../../.. ; pwd)
endif
endif

$(warning ACL2_DIR is $(ACL2_DIR))

export ACL2 ?= $(ACL2_DIR)/saved_acl2
export ACL2_SYSTEM_BOOKS ?= $(ACL2_DIR)/books

DIRS = translator examples/thacker
include $(ACL2_SYSTEM_BOOKS)/Makefile-subdirs

# For target.cert:

include $(ACL2_SYSTEM_BOOKS)/Makefile-generic
top: target.cert

=== books/workshops/2003/kaufmann/support/Makefile ===
DIRS = input rtl/tool rtl
include ../../../../Makefile-subdirs

=== books/workshops/2018/mehta/test/Makefile ===
test: test-cp-replicant-1 test-cp-replicant-2 test-cp-replicant-3 \
test-cp-replicant-4 test-mkfs-replicant-1 test-mkfs-replicant-2 \
test-mkfs-replicant-3

.PHONY: clean-mountpoint test test-cp-replicant-1 \
test-cp-replicant-2 test-cp-replicant-3 test-cp-replicant-4 \
test-mkfs-replicant-1 test-mkfs-replicant-2 test-mkfs-replicant-3

.PHONY: debug-create-dir-and-file debug-create-dir debug-do-nothing \
debug-create-dir-copy-file

DISK=disk1.raw
SIZE=70000
MOUNTPOINT=mount1
UID=$(shell id -u)
GID=$(shell id -g)

clean-mountpoint:
	rm -rf $(MOUNTPOINT)

clean-fusepoint:
	rm -rf  $(MOUNTPOINT)

$(MOUNTPOINT):
	rm -rf $(MOUNTPOINT)
	mkdir -p $(MOUNTPOINT)

test-cp-replicant-1: cp-ref-output-1.txt cp-output-1.txt
	diff -u -i cp-ref-output-1.txt cp-output-1.txt

test-cp-replicant-2: cp-ref-output-2.txt cp-output-2.txt
	diff -u -i cp-ref-output-2.txt cp-output-2.txt

test-cp-replicant-3: cp-ref-output-3.txt cp-output-3.txt
	diff -u -i cp-ref-output-3.txt cp-output-3.txt

test-cp-replicant-4: cp-ref-output-4.txt cp-output-4.txt
	diff -u -i cp-ref-output-4.txt cp-output-4.txt

test-cp-replicant-5: cp-ref-output-5.txt cp-output-5.txt
	diff -u -i cp-ref-output-5.txt cp-output-5.txt

test-mkfs-replicant-1: mkfs-ref-output-1.txt mkfs-output-1.txt
	diff -u -i mkfs-ref-output-1.txt mkfs-output-1.txt

test-mkfs-replicant-2: mkfs-ref-output-2.txt mkfs-output-2.txt
	diff -u -i mkfs-ref-output-2.txt mkfs-output-2.txt

test-mkfs-replicant-3: mkfs-ref-output-3.txt mkfs-output-3.txt
	diff -u -i mkfs-ref-output-3.txt mkfs-output-3.txt

cp-ref-output-1.txt cp-output-1.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	echo "four" >  $(MOUNTPOINT)/vmlinuz
	cat  $(MOUNTPOINT)/vmlinuz > cp-ref-output-1.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-1.txt" \
	CP_INPUT="VMLINUZ    " $(ACL2) < cp-replicant.lisp

cp-ref-output-2.txt cp-output-2.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-1204-bytes.txt  $(MOUNTPOINT)/vmlinuz
	cat  $(MOUNTPOINT)/vmlinuz > cp-ref-output-2.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-2.txt" \
	CP_INPUT="VMLINUZ    " $(ACL2) < cp-replicant.lisp

cp-ref-output-3.txt cp-output-3.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-1204-bytes.txt  $(MOUNTPOINT)/vmlinuz
	cp input-4623-bytes.txt  $(MOUNTPOINT)/initrd.img
	cat  $(MOUNTPOINT)/initrd.img > cp-ref-output-3.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-3.txt" \
	CP_INPUT="INITRD  IMG" $(ACL2) < cp-replicant.lisp

cp-ref-output-4.txt cp-output-4.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	for i1 in $(shell seq 1 32); do \
		cp input-1204-bytes.txt  $(MOUNTPOINT)/initrd$$i1.img; \
	done
	cp input-4623-bytes.txt  $(MOUNTPOINT)/initrd.img
	cat  $(MOUNTPOINT)/initrd.img > cp-ref-output-4.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-4.txt" \
	CP_INPUT="INITRD  IMG" $(ACL2) < cp-replicant.lisp

cp-ref-output-5.txt cp-output-5.txt: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	cp input-1204-bytes.txt  $(MOUNTPOINT)/initrd.img
	sync  $(MOUNTPOINT)/initrd.img
	rm  $(MOUNTPOINT)/initrd.img
	for i1 in $(shell seq 1 32); do \
		cp input-1204-bytes.txt  $(MOUNTPOINT)/initrd$$i1.img; \
	done
	cp input-4623-bytes.txt  $(MOUNTPOINT)/initrd.img
	cat  $(MOUNTPOINT)/initrd.img > cp-ref-output-5.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	env DISK=$(DISK) CP_OUTPUT="cp-output-5.txt" \
	CP_INPUT="INITRD  IMG" $(ACL2) < cp-replicant.lisp

mkfs-ref-output-1.txt mkfs-output-1.txt: $(MOUNTPOINT) \
mkfs.fat-3.0.28-replicant.lisp
	rm -f $(DISK)
	(mkfs.fat -C -v -F 32 -s 1 $(DISK) $(SIZE)) > mkfs-ref-output-1.txt
	env DISK=$(DISK) MKFS_OUTPUT="mkfs-output-1.txt" $(ACL2) < \
	mkfs.fat-3.0.28-replicant.lisp

mkfs-ref-output-2.txt mkfs-output-2.txt: $(MOUNTPOINT) \
mkfs.fat-3.0.28-replicant.lisp
	rm -f $(DISK)
	(mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)) > mkfs-ref-output-2.txt
	env DISK=$(DISK) MKFS_OUTPUT="mkfs-output-2.txt" $(ACL2) < \
	mkfs.fat-3.0.28-replicant.lisp

# this case does not actually produce a valid FAT32 filesystem, since
# there are fewer than 65525 clusters.
mkfs-ref-output-3.txt mkfs-output-3.txt: $(MOUNTPOINT) \
mkfs.fat-3.0.28-replicant.lisp
	rm -f $(DISK)
	(mkfs.fat -C -v -F 32 -s 4 $(DISK) $(SIZE)) > mkfs-ref-output-3.txt
	env DISK=$(DISK) MKFS_OUTPUT="mkfs-output-3.txt" $(ACL2) < \
	mkfs.fat-3.0.28-replicant.lisp

debug-do-nothing: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	sleep 1
	sudo umount $(MOUNTPOINT)
	true

debug-create-dir: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	mkdir  $(MOUNTPOINT)/tmp
	sleep 1
	sudo umount $(MOUNTPOINT)
	true

debug-create-dir-and-file: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	mkdir  $(MOUNTPOINT)/tmp
	touch  $(MOUNTPOINT)/tmp/ticket1.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	true

debug-create-dir-copy-file: $(MOUNTPOINT) cp-replicant.lisp
	rm -f $(DISK)
	mkfs.fat -C -v -F 32 -s 2 $(DISK) $(SIZE)
	sudo mount -o loop,uid=$(UID),gid=$(GID) -t msdos $(DISK) $(MOUNTPOINT)
	mkdir  $(MOUNTPOINT)/tmp
	touch  $(MOUNTPOINT)/tmp/ticket1.txt
	cp  $(MOUNTPOINT)/tmp/ticket1.txt  $(MOUNTPOINT)/tmp/ticket2.txt
	sleep 1
	sudo umount $(MOUNTPOINT)
	true

=== debian/changelog ===
acl2 (8.2dfsg-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:09:23 +0100

acl2 (8.2dfsg-3) unstable; urgency=medium

  * revert -2, set *split-files* to 100000 instead

 -- Camm Maguire <camm@debian.org>  Fri, 27 Dec 2019 15:15:44 +0000

acl2 (8.2dfsg-2) unstable; urgency=medium

  * Temporarily set GCL_MEM_MULTIPLE to 0.75 in saved_acl2 build to
    workaround gcc oom issues

 -- Camm Maguire <camm@debian.org>  Thu, 26 Dec 2019 20:47:09 +0000

acl2 (8.2dfsg-1) unstable; urgency=medium

  * New upstream release
  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 19 Dec 2019 15:30:07 +0000

acl2 (8.1dfsg-6) unstable; urgency=medium

  * build-dep gcl ( >= 2.6.12-90)
  * latest standards

 -- Camm Maguire <camm@debian.org>  Mon, 09 Dec 2019 14:21:30 +0000

acl2 (8.1dfsg-5) unstable; urgency=medium

  * build-dep gcl ( >= 2.6.12-89)
  * Bug fix: "acl2 - FTBFS on ppc64el - invalid Unknown reloc type 31",
    thanks to thierry.fauck@fr.ibm.com</a>; (Closes: #944222).

 -- Camm Maguire <camm@debian.org>  Sun, 08 Dec 2019 15:13:52 +0000

acl2 (8.1dfsg-4) unstable; urgency=medium

  * source-only upload
  * Bug fix: "Build-Depends on emacs25 which has been removed from
    unstable/bullseye", thanks to Paul Gevers (Closes: #941641).

 -- Camm Maguire <camm@debian.org>  Thu, 31 Oct 2019 17:17:49 +0000

=== debian/control ===
Source: acl2
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: gcl ( >= 2.6.12-92), libgmp3-dev, libreadline-dev, emacs-gtk | emacsen, debhelper ( >= 5), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common, texinfo
Standards-Version: 4.4.1

Package: acl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: acl2-source, acl2-books
Suggests: acl2-emacs
Description: Computational Logic for Applicative Common Lisp: main binary
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the base ACL2 binary. 

Package: acl2-source
Architecture: all
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Depends: ${misc:Depends}	  
Description: Computational Logic for Applicative Common Lisp: source files
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the lisp source files to the main ACL2 binary.

Package: acl2-emacs
Architecture: all
Depends: acl2 (>= ${source:Version}), emacs-gtk | emacsen, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: emacs interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains an emacs interface to ACL2.

Package: acl2-infix
Architecture: any
Recommends: acl2-infix-source (= ${source:Version})
Depends: acl2 (= ${binary:Version}), texlive-latex-recommended, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains utilities and libraries to access ACL2 via an
 infix notation similar to that used in many non-lisp programming
 languages.

Package: acl2-infix-source
Architecture: all
Depends: ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix source
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the source files to the infix interface to
 ACL2.

Package: acl2-books
Architecture: any
Depends: acl2 (= ${binary:Version}), acl2-books-certs (= ${source:Version}), acl2-books-source (= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: compiled libraries
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains numerous precompiled and precertified libraries
 for use in proving theorems with ACL2.  Serious users will no doubt
 want to install this package.

Package: acl2-books-source
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library sources
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains source lisp files to the compiled libraries
 supplied in the ACL2-books package.

Package: acl2-books-certs
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library certificates
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This file contains certification records for the various precompiled
 libraries supplied in the ACL2-books package.  ACL2 essentially
 requires that all included books be certified before use.

Package: acl2-doc
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Architecture: all
Section: doc
Description: Computational Logic for Applicative Common Lisp: documentation
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the documentation for ACL2.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

# ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION:=500000000
# MAXJOBS:=$(shell gcl -batch -eval \
#    "(print \
#       (multiple-value-bind (a b c d) (si::heap-report) \
# 	(min 8 \
# 	     (ceiling (/ (- d c) (/ a 8)) \
#                       ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}))))")

NUMJOBS:=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
# NUMJOBS:=$(shell if test $(NUMJOBS) -gt ${MAXJOBS}; then echo ${MAXJOBS} ; else echo $(NUMJOBS); fi)

#books/workshops:
#	mkdir $@

#init.lsp.ori: 
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori 

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

debian/acl2-emacs.emacsen-startup: debian/acl2-emacs.emacsen-startup.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

#pgcl:
#	echo "(progn (setq compiler::*split-files* 100000)(si::save-system \"$@\"))" | GCL_ANSI=t gcl

saved_acl2: # pgcl #debian/patches_applied $(DLOPEN_T) 
#	gcl -batch -eval "(bye #-native-reloc 1)" || \
#		(gcl -batch -eval '(load "debian/dlopen.lisp")' && $(MAKE) do_saved)
#	gcl -batch -eval "(bye #+native-reloc 1)" || $(MAKE) GCL_ANSI=t LISP=gcl
	$(MAKE) GCL_ANSI=t LISP=gcl
	mv *$@.gcl $@

saved_acl2.c: saved_acl2
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q (in-package :acl2) " \
	      "#+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | HOME=$$(pwd) ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2
	HOME=$$(pwd) $(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2.c
	cp saved_acl2 saved_acl2.ori
	HOME=$$(pwd) $(MAKE) certify-books-short
	cp saved_acl2.ori saved_acl2

#	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \

debian/test.log: saved_acl2.c
	mv saved_acl2 saved_acl2.ori
	cp $< saved_acl2
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	GCL_MULTIPROCESS_MEMORY_POOL=t \
	$(MAKE) -j $(NUMJOBS) -l 2.95 certify-books 2>&1 | tee $@ & j=$$! ; \
	while sleep 1800; do echo Tick; done & k=$$! ; \
	wait $$j ; kill $$k
#	>$@ 2>&1 & j=$$! ; \
#	while sleep 1800; do echo Tick; done & k=$$! ; tail -f debian/test.log & l=$$! ; \
#	wait $$j ; kill $$k $$l
#	[ -f $@ ] && ! fgrep '**' $@ || (echo FULL TEST FAILS ;\
#		for i in $$(find books -name "*.out"); do \
#			if ! [ -e $${i%out}cert ] ; then \
#				echo $$i ; \
#				cat $$i ; \
#			fi ; \
		done)
	mv saved_acl2.ori saved_acl2
	[ -f $@ ] && ( ! fgrep '**' $@ || true ) 
	  # gcl -batch -eval \
          #   "(bye \
	  # 	  #-native-reloc 0 \
          #         #+native-reloc \
          #           (let ((w (multiple-value-bind (a b c d) (si::heap-report) (/ (- d c) (/ a 8))))) \
	  # 		 (format t \"certification run with ~s heap words~%\" w) \
	  # 		 (if (< w ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}) 0 1)))")

books/interface/infix/Makefile: books/interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2,1" $< > $@

infix-stamp: books/interface/infix/Makefile saved_acl2
	cd books/interface/infix && make -f Makefile compile 
	cd books/interface/infix && make -f Makefile example 
#	cd books/interface/infix && make -f Makefile events 
	touch $@

doc/TEX/acl2-book.ps.gz: saved_acl2
	HOME=$$(pwd) $(MAKE) DOC
	rm -f doc/HTML/LICENSE
	find doc -empty -exec rm {} \;

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp # doc/TEX/acl2-book.ps.gz
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: books/interface/infix/Makefile
	rm -f infix-stamp 
	cd books/interface/infix && make -f Makefile clean
	rm -f books/interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied: 
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-emacs acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

OVERRIDES:= $(shell find debian/ -name "*.lintian-overrides.in" |sed 's,\.in,,g')

clean: infix_clean #debian/patches_unapplied books/workshops
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	$(MAKE) clean-all
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f saved_acl2 init_nsaved1_acl2.lsp worklispext
	rm -f debian/mini-proveall.out books/short-test.log debian/test.log
#	! [ -e init.lsp.ori ] || mv init.lsp.ori init.lsp
	rm -f foo.lsp nsaved_acl2
	for i in data c h ; do \
		for j in $$(find -name "*.$$i") ; do\
			k=$$(echo $$j | sed "s,\.$$i$$,,1") ;\
			! [ -e $$k.lisp ] || rm $$j ; \
		done ; \
	done
	rm -f books/bdd/benchmarks.data acl2r.lisp tmp
	rm -f debian/dpatches $(INSTALLS) $(LINKS) debian/README.Debian saved_acl2*
	rm -f debian/dlopen.lisp debian/acl2-emacs.emacsen-startup
	rm -f debian/acl2.sh pgcl books/Makefile-tmp books/coi/gensym/gensym.out sys-proclaim.lisp
	rm -f books/coi/gensym/Makefile-deps books/coi/gensym/workxxx.gensym books/system/doc/rendered-doc.lsp
	rm -rf doc/HTML-old doc/EMACS-old doc/acl2-wc.txt books/std/io/test.sao
	rm -f books/centaur/bitops/bitsets-opt-raw.o books/centaur/vl/util/gc-raw.o \
		books/centaur/misc/tshell-raw.o books/centaur/vl/Makefile-tmp \
		books/build/Makefile-sources books/build/Makefile-certs 
	rm -f books/build/acl2-exports.certdep books/build/acl2-version.certdep \
		books/build/first-order-like-terms-and-out-arities.certdep \
